<?php
/************************************************************
Program		Sorg Monitor
Filename	graph.php
Version		1.00
Last update	19/09/2005
************************************************************/


// Include
require_once ('config.php');
require_once ('inc/inc_mysql.php');
require_once ('lang/'.$default_lang.'.php');
require_once ('libchart/libchart.php');

session_start();

// Inits
$meta_data = '';


if (($require_login == 2 || $require_login == 3) && $_SESSION['sorg_mon'] != $admin['username']) {
	header ('location: login.php?return='.urlencode($_SERVER['REQUEST_URI']));
	exit();
}

// Objet definitions
$db = new MySQL($db_access['host'], $db_access['database'], $db_access['username'], $db_access['password']);
$chart = new VerticalChart(900, 400);

if (isset($_GET['url'])) {
	$url = addslashes($_GET['url']);
} else {
	$url = $default_url;
} 

// Offset stuff
if (isset($_GET['offset'])) {
	$offset = (int)$_GET['offset'];
} else {
	$offset = 0;
}

$html .= '<a href="graph.php?url='.urlencode($url).'&amp;offset='.($offset - 1).'" title="'.$lang['previous'].'">&lt;&lt;&lt;</a> ';

if ($offset < 0)
	$html .= '<a href="graph.php?url='.urlencode($url).'&amp;offset='.($offset + 1).'" title="'.$lang['next'].'">&gt;&gt;&gt;</a>';
else
	$html .= '<span title="'.$lang['next'].'">&gt;&gt;&gt;</span>';

$min_timestamp = time() - 3600 * ($graph_span - $offset * $graph_nav); 
$max_timestamp = time() + 3600 * $offset * $graph_nav;

$q0 = $db->query("SELECT timestamp, fetch_time, failure FROM data WHERE timestamp > $min_timestamp AND timestamp < $max_timestamp AND url = '$url' ORDER BY timestamp ASC");

if (($no_req = $db->num_rows()) == 0) {
	echo ('<center><h2>'.$lang['out_of_range'].'</h2></center>');
	exit();
}

while ($var = $db->assoc($q0)) {
	if  (date('H', $var['timestamp']) == $date) {
		$dis_date = '';
	} else {
		$date = $dis_date = date('H', $var['timestamp']);
	}
	$chart->addPoint(new Point($dis_date, $var['fetch_time'] * 1));
}

$q0 = $db->query("SELECT max(fetch_time) AS max_time, sum(fetch_time) AS tot_fetch_time, sum(failure) AS tot_failure, round((1-avg(failure))*100,1) AS uptime FROM data WHERE timestamp > $min_timestamp AND timestamp < $max_timestamp AND url = '$url'");

$var = $db->assoc($q0);

$chart->setLowerBound(0);
if ($var['max_time'] < 4)
	$chart->setUpperBound(4);

$chart->setTitle($lang['resp_time'].stripslashes($url));
$chart->render('generated/graph.png');

// Pruning
if ($prune_freq != 0) {
	// No need to overload the database.
	if (rand(1, 10) == 1) {
		$prune = time() - 604800 * $prune_freq; // 604800 = 60 * 60 * 24 * 7 
		$q0 = $db->query("DELETE FROM data WHERE timestamp < $prune");
	}
}

// Meta refresh
if ($graph_refresh) {
	$meta_data = '<meta http-equiv="refresh" content="'.($graph_refresh * 60).';url='.$_SERVER['REQUEST_URI'].'">';
}

$q0 = $db->close();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<?php echo ($meta_data); ?>
<link rel="stylesheet" type="text/css" href="css/default.css" />
<title><?php echo ($lang['resp_time'].stripslashes($url)); ?></title>
</head>
<body>
<center><h2><?php echo ($lang['stats'].date('d/m/Y', $min_timestamp)); ?> - <?php echo (date('d/m/Y', $max_timestamp)); ?></h2>
<?php echo ($html); ?><br /><br />
<a href="./" title=""><img src="generated/graph.png" /></a>
<h2><?php echo ($lang['extra_info']); ?></h2></center>
<ul>
<li><?php echo ($lang['no_req'].$no_req.' ('.$lang['failed_req'].$var['tot_failure'].')'); ?></li>
<li><?php echo ($lang['uptime'].$var['uptime']); ?>%</li> 
<li><?php echo ($lang['avg_res_time']); if ($no_req == $var['tot_failure']) echo ('0s'); else echo (round($var['tot_fetch_time']/($no_req - $var['tot_failure']), 2).'s'); ?></li>
</ul>
</body>
</html>
